# coding:utf-8
import Tkinter
import ScrolledText as tkst
import tkMessageBox


class CreateSensorPanel(Tkinter.Frame):

    def __init__(self, r=10, width=500, height=150, master=None):
        print"class CreateSensorPanel __init__()"
        Tkinter.Frame.__init__(self, master)

        self.master.title(u"Drone Viewer")
        self.master.resizable(0, 0)
        self.mainframe = Tkinter.Frame(self.master)
        self.mainframe.pack()

        self.topFrame = Tkinter.LabelFrame(self.master, 
                                        text="Flight Info", 
                                        font=("Helvetica", "12"),
                                        fg="#980098" )
        self.topFrame.pack(padx=10, pady=5, 
                            fill=Tkinter.X, anchor=Tkinter.W)

        self.gpsFrame = Tkinter.LabelFrame(self.master, 
                                        text="GPS Info", 
                                        font=("Helvetica", "12"),
                                        fg="#980098" )
        self.gpsFrame.pack(padx=10, pady=5, 
                            fill=Tkinter.X, anchor=Tkinter.W)

        self.sensorFrame = Tkinter.LabelFrame(self.master, 
                                            text="Sensor Info", 
                                            font=("Helvetica", "12"),
                                            fg="#980098" )
        self.sensorFrame.pack(padx=10, pady=5, 
                            fill=Tkinter.X, anchor=Tkinter.W)

        self.errFrame = Tkinter.LabelFrame(self.master, 
                                        text="Error Info", 
                                        font=("Helvetica", "12"),
                                        fg="#980098" )
        self.errFrame.pack(padx=10, pady=5, 
                            fill=Tkinter.X, anchor=Tkinter.W)

        self.build_sensor_panel()
        self.sensor_sts_init()

    def build_sensor_panel(self):
        print"class CreateSensorPanel build_sensor_panel() start"

        self.create_battery_info()
        self.create_flttime_info()
        self.create_fltmd_info()
        self.create_movemode_info()
        self.create_droneIOState_info()
        self.create_distance_info()
        self.create_GPShome_info()
        self.create_GPSdrone_info()
        self.create_mag_info()
        self.create_gyro_info()
        self.create_maxspeed_info()
        self.create_accel_info()
        self.create_barometer_info()
        self.create_err_info()

        print"class CreateSensorPanel build_sensor_panel() end"

    def create_battery_info(self):
        self.frame = Tkinter.Frame(self.topFrame)
        self.frame.grid(row=0, column=0, padx=10)
        self.label_batt = Tkinter.Label(
            self.frame, text="Battery")
        self.label_batt.grid(row=0, column=0, columnspan=2, sticky=Tkinter.W)

        self.batt_V_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.frame, textvariable=self.batt_V_var,
            font=("Helvetica", "16"), fg="black", bg="white")
        self.label_sts.grid(row=1, column=0, pady=5)

        self.label_V = Tkinter.Label(self.frame, text="V")
        self.label_V.grid(row=1, column=1, padx=2)

        self.batt_mA_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.frame, textvariable=self.batt_mA_var,
            font=("Helvetica", "16"), fg="black", bg="white")
        self.label_sts.grid(row=1, column=2, pady=5)

        self.label_mA = Tkinter.Label(self.frame, text="mA")
        self.label_mA.grid(row=1, column=3, padx=2)

    def create_flttime_info(self):
        self.frame = Tkinter.Frame(self.topFrame)
        self.frame.grid(row=0, column=1, padx=10, sticky=Tkinter.W)
        self.label_time = Tkinter.Label(
            self.frame, text="Flight Time")
        self.label_time.grid(row=0, column=0, columnspan=2)

        self.flight_time = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.frame, textvariable=self.flight_time,
            font=("Helvetica", "16"), fg="black", bg="white")
        self.label_sts.grid(row=1, column=0, pady=5)

    def create_fltmd_info(self):
        self.frame = Tkinter.Frame(self.topFrame)
        self.frame.grid(row=0, column=2, padx=10, sticky=Tkinter.W)
        self.label_fltmd = Tkinter.Label(
            self.frame, text="Flight Mode")
        self.label_fltmd.grid(row=0, column=0, columnspan=2)

        self.fltmd_var = Tkinter.StringVar()
        self.label_fltmd_sts = Tkinter.Label(
            self.frame, textvariable=self.fltmd_var,
            font=("Helvetica", "16"), fg="black", bg="white")
        self.label_fltmd_sts.grid(row=1, column=0, pady=5)

    def create_movemode_info(self):
        self.frame = Tkinter.Frame(self.topFrame)
        self.frame.grid(row=0, column=3, padx=10, sticky=Tkinter.W)
        self.label_movemode = Tkinter.Label(
            self.frame, text="Move Mode")
        self.label_movemode.grid(row=0, column=0, columnspan=2)

        self.movemode_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.frame, textvariable=self.movemode_var,
            font=("Helvetica", "16"), fg="black", bg="white")
        self.label_sts.grid(row=1, column=0, pady=5)

    def create_droneIOState_info(self):
        self.frame = Tkinter.Frame(self.topFrame)
        self.frame.grid(row=0, column=4, padx=10, sticky=Tkinter.W)
        self.label_dronestate = Tkinter.Label(
            self.frame, text="Drone State")
        self.label_dronestate.grid(row=0, column=0, columnspan=2)

        self.dronestate_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.frame, textvariable=self.dronestate_var,
            font=("Helvetica", "16"), fg="black", bg="white")
        self.label_sts.grid(row=1, column=0, pady=5)

    def create_distance_info(self):
        self.frame = Tkinter.Frame(self.gpsFrame)
        self.frame.grid(row=0, column=0, padx=10, sticky=Tkinter.NW)

        self.label_distance = Tkinter.Label(
            self.frame, text="Distance\n(Home-Drone)", justify=Tkinter.LEFT)
        self.label_distance.grid(row=0, column=0, columnspan=2)

        self.distance_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.frame, textvariable=self.distance_var,
            font=("Helvetica", "16"), fg="black", bg="white")
        self.label_sts.grid(row=1, column=0, pady=5)

        self.label_meter = Tkinter.Label(self.frame, text="m")
        self.label_meter.grid(row=1, column=1)

    def create_GPShome_info(self):
        self.frame = Tkinter.Frame(self.gpsFrame)
        self.frame.grid(
            row=0, column=1, columnspan=3, padx=10, sticky=Tkinter.W)

        self.label_GPS = Tkinter.Label(
            self.frame, text="Home")
        self.label_GPS.grid(
            row=0, column=0, rowspan=3, padx=5, pady=7, sticky=Tkinter.NW)

        self.label_lan = Tkinter.Label(self.frame, text="lat.")
        self.label_lan.grid(row=0, column=1, padx=5, pady=5)

        self.lan_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.frame, textvariable=self.lan_var, 
            font=("Helvetica", "11"), fg="black", bg="white")
        self.label_sts.grid(row=0, column=2, pady=5, sticky=Tkinter.W)

        self.label_lon = Tkinter.Label(
            self.frame, text="lon.")
        self.label_lon.grid(row=1, column=1, padx=5, pady=5)

        self.lon_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.frame, textvariable=self.lon_var, 
            font=("Helvetica", "11"), fg="black", bg="white")
        self.label_sts.grid(row=1, column=2, pady=5, sticky=Tkinter.W)

        self.label_alt = Tkinter.Label(
            self.frame, text="alt.")
        self.label_alt.grid(row=2, column=1, padx=5, pady=5)

        self.alt_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.frame, textvariable=self.alt_var, 
            font=("Helvetica", "11"), fg="black", bg="white")
        self.label_sts.grid(row=2, column=2, pady=5, sticky=Tkinter.W)

    def create_GPSdrone_info(self):
        self.frame = Tkinter.Frame(self.gpsFrame)
        self.frame.grid(
            row=0, column=4, columnspan=3, padx=10, sticky=Tkinter.W)

        self.label_dGPS = Tkinter.Label(
            self.frame, text="Drone")
        self.label_dGPS.grid(
            row=0, column=0, rowspan=3, padx=5, pady=7, sticky=Tkinter.NW)

        self.label_dlan = Tkinter.Label(
            self.frame, text="lat.")
        self.label_dlan.grid(row=0, column=1, padx=5, pady=5)

        self.drlan_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.frame, textvariable=self.drlan_var, 
            font=("Helvetica", "11"), fg="black", bg="white")
        self.label_sts.grid(row=0, column=2, pady=5, sticky=Tkinter.W)

        self.label_dlon = Tkinter.Label(
            self.frame, text="lon.")
        self.label_dlon.grid(row=1, column=1, padx=5, pady=5)

        self.drlon_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.frame, textvariable=self.drlon_var, 
            font=("Helvetica", "11"), fg="black", bg="white")
        self.label_sts.grid(row=1, column=2, pady=5, sticky=Tkinter.W)

        self.label_dalt = Tkinter.Label(
            self.frame, text="alt.")
        self.label_dalt.grid(row=2, column=1, padx=5, pady=5)

        self.dralt_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.frame, textvariable=self.dralt_var, 
            font=("Helvetica", "11"), fg="black", bg="white")
        self.label_sts.grid(row=2, column=2, pady=5, sticky=Tkinter.W)

    def create_gyro_info(self):
        self.Frame = Tkinter.LabelFrame(self.sensorFrame, text="Gyro(rad)")
        self.Frame.grid(row=1, column=0, columnspan=2,
                        padx=5, pady=5, sticky=Tkinter.NW)

        self.label_roll = Tkinter.Label(
            self.Frame, text="roll")
        self.label_roll.grid(row=2, column=0, padx=5, pady=5)

        self.roll_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.Frame, textvariable=self.roll_var, 
            font=("Helvetica", "11"), fg="black", bg="white")
        self.label_sts.grid(row=2, column=1, padx=5, pady=5, sticky=Tkinter.W)

        self.label_pitch = Tkinter.Label(
            self.Frame, text="pitch")
        self.label_pitch.grid(row=3, column=0, padx=5, pady=5)

        self.pitch_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.Frame, textvariable=self.pitch_var, 
            font=("Helvetica", "11"), fg="black", bg="white")
        self.label_sts.grid(row=3, column=1, padx=5, pady=5, sticky=Tkinter.W)

        self.label_yaw = Tkinter.Label(
            self.Frame, text="yaw")
        self.label_yaw.grid(row=4, column=0, padx=5, pady=5)

        self.yaw_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.Frame, textvariable=self.yaw_var, 
            font=("Helvetica", "11"), fg="black", bg="white")
        self.label_sts.grid(row=4, column=1, padx=5, pady=5, sticky=Tkinter.W)

    def create_accel_info(self):
        self.Frame = Tkinter.LabelFrame(
            self.sensorFrame, text="Acceleration(m/s)")
        self.Frame.grid(row=1, column=2, padx=5, pady=5, sticky=Tkinter.NW)

        self.label_x = Tkinter.Label(self.Frame, text="x")
        self.label_x.grid(row=2, column=2, padx=10, pady=5)

        self.x_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.Frame, textvariable=self.x_var, 
            font=("Helvetica", "11"), fg="black", bg="white")
        self.label_sts.grid(row=2, column=3, pady=5, sticky=Tkinter.W)

        self.label_y = Tkinter.Label(self.Frame, text="y")
        self.label_y.grid(row=3, column=2, padx=10, pady=5)

        self.y_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.Frame, textvariable=self.y_var, 
            font=("Helvetica", "11"), fg="black", bg="white")
        self.label_sts.grid(row=3, column=3, pady=5, sticky=Tkinter.W)

        self.label_z = Tkinter.Label(self.Frame, text="z")
        self.label_z.grid(row=4, column=2, padx=10, pady=5)

        self.z_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.Frame, textvariable=self.z_var, 
            font=("Helvetica", "11"), fg="black", bg="white")
        self.label_sts.grid(row=4, column=3, pady=5, sticky=Tkinter.W)

    def create_mag_info(self):
        self.frame = Tkinter.Frame(self.sensorFrame)
        self.frame.grid(row=0, column=0, padx=5, pady=5, sticky=Tkinter.NW)

        self.label_mag = Tkinter.Label(
            self.frame, text="heading(deg)")
        self.label_mag.grid(row=0, column=0, padx=5)

        self.mag_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.frame, textvariable=self.mag_var, 
            font=("Helvetica", "11"), fg="black", bg="white")
        self.label_sts.grid(row=0, column=1, sticky=Tkinter.W)

    def create_maxspeed_info(self):
        self.frame = Tkinter.Frame(self.sensorFrame)
        self.frame.grid(row=0, column=2, padx=5, pady=5, sticky=Tkinter.NW)

        self.label_maxspeed = Tkinter.Label(
            self.frame, text="Target Speed(m/s)")
        self.label_maxspeed.grid(row=0, column=0, padx=5)

        self.maxspeed_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.frame, textvariable=self.maxspeed_var, font=("Helvetica", "11"), fg="black", bg="white")
        self.label_sts.grid(row=0, column=1, sticky=Tkinter.W)

    def create_barometer_info(self):
        self.frame = Tkinter.Frame(self.sensorFrame)
        self.frame.grid(row=0, column=4, columnspan=3,
                        padx=5, pady=5, sticky=Tkinter.W)

        self.label_temp = Tkinter.Label(
            self.frame, text="Temperatue(C)")
        self.label_temp.grid(row=0, column=0, padx=5)

        self.temp_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.frame, textvariable=self.temp_var, font=("Helvetica", "11"), fg="black", bg="white")
        self.label_sts.grid(row=0, column=1, sticky=Tkinter.W)

        self.label_press = Tkinter.Label(
            self.frame, text="Pressure(hPa)")
        self.label_press.grid(row=0, column=2, padx=5)

        self.press_var = Tkinter.StringVar()
        self.label_sts = Tkinter.Label(
            self.frame, textvariable=self.press_var, font=("Helvetica", "11"), fg="black", bg="white")
        self.label_sts.grid(row=0, column=3, sticky=Tkinter.W)

    def create_err_info(self):

        self.frame = Tkinter.Frame(self.errFrame)
        self.frame.grid(padx=5, pady=5, sticky=Tkinter.W)

        self.text_sys_err = tkst.ScrolledText(
            master=self.frame, wrap=Tkinter.WORD, font=("Helvetica", "11"), fg="red", width=68, height=3)
        self.text_sys_err.grid(padx=5, pady=5, sticky=Tkinter.W)

    def sensor_sts_init(self):

        self.batt_V_var.set("----")
        self.batt_mA_var.set("----")
        self.flight_time.set("--:--")
        self.fltmd_var.set("------")
        self.movemode_var.set("------")
        self.dronestate_var.set("------")
        self.distance_var.set("-----")
        self.lan_var.set("------------")
        self.lon_var.set("------------")
        self.alt_var.set("------------")
        self.drlan_var.set("------------")
        self.drlon_var.set("------------")
        self.dralt_var.set("------------")
        self.roll_var.set("-.-")
        self.pitch_var.set("-.-")
        self.yaw_var.set("-.-")
        self.maxspeed_var.set("-.-")
        self.x_var.set("-.-")
        self.y_var.set("-.-")
        self.z_var.set("-.-")
        self.mag_var.set("----")
        self.temp_var.set("--.--")
        self.press_var.set("----")
        self.text_sys_err.delete('1.0', Tkinter.END)

        """
        self.batt_V_var.set("14.9")
        self.batt_mA_var.set("0000")
        self.flight_time.set("0:13")
        self.fltmd_var.set("GUIDED")
        self.movemode_var.set("Absolute")
        self.dronestate_var.set("Hovering")
        self.distance_var.set("009.6")
        self.lan_var.set("37.522564")
        self.lon_var.set("139.93866")
        self.alt_var.set("209.1")
        self.drlan_var.set("37.52257")
        self.drlon_var.set("139.938662")
        self.dralt_var.set("9.6")
        self.roll_var.set("0.027891")
        self.pitch_var.set("-0.021315")
        self.yaw_var.set("2.444067")
        self.maxspeed_var.set("5.0")
        self.x_var.set("-0.1")
        self.y_var.set("0.0")
        self.z_var.set("0.1")
        self.mag_var.set("140")
        self.temp_var.set("36.7")
        self.press_var.set("980.65")
        self.text_sys_err.insert(
        Tkinter.INSERT, "[E]Communication with the GCS has been lost. Start the RTL.")
        """


if __name__ == "__main__":
    print "f = CreateSensorPanel()"
    f = CreateSensorPanel()
    print "f.pack()"
    f.pack()
    print "f.mainloop()"
    f.mainloop()
