import create_sensor_panel as panel
import math
import drone_distance_cal as dr_math

if __name__ == "__main__":
    drone_view = panel.CreateSensorPanel()
    drone_view.pack()

    tm = 155
    bat_lv = 13.9
    fltmode = "STABILIZE"
    movemode = "Absolute"

    hm_lat = 37.055576
    hm_lon = 140.819016
    hm_alt = 160.6

    dr_lat = 37.055587
    dr_lon = 140.819035
    dr_alt = 14.9

    roll = 0.056576
    pitch = 0.043432
    yaw = 0.843409

    tar_spd = 5.0
    x = 0.0
    y = 0.1
    z = 0.1

    compass = 48.0
    temp = 16.2
    pres = 100074.0

    # Battery level
    drone_view.batt_level.set(str(bat_lv))

    # flight time
    tm_min = tm // 60
    tm_sec = tm % 60
    tm_str = str(tm_min) + ":" + str(tm_sec)
    drone_view.flight_time.set(tm_str)

    drone_view.fltmd_var.set(fltmode)
    if fltmode in {"GUIDED", "RTL"}:
        drone_view.label_fltmd_sts.configure(bg="white")
    elif fltmode == "LOITER":
        drone_view.label_fltmd_sts.configure(bg="green")
    elif fltmode == "STABILIZE":
        drone_view.label_fltmd_sts.configure(bg="yellow")
    elif fltmode == "AUTO":
        drone_view.label_fltmd_sts.configure(bg="red")
    else:
        drone_view.label_fltmd_sts.configure(bg="white")
    drone_view.movemode_var.set(movemode)

    # distance
    d = dr_math.DroneMathmetics()
    d_y = d.distance_math(hm_lon, dr_lon, hm_lat, dr_lat, 0, dr_alt)
    d_y = round(d_y, 1)
    drone_view.distance_var.set(str(d_y))

    print d_y

    # GPS data (Home)
    drone_view.lan_var.set(str(hm_lat))
    drone_view.lon_var.set(str(hm_lon))
    drone_view.alt_var.set(str(hm_alt))

    # GPS data (drone)
    drone_view.drlan_var.set(str(dr_lat))
    drone_view.drlon_var.set(str(dr_lon))
    drone_view.dralt_var.set(str(dr_alt))

    # Gyro
    drone_view.roll_var.set(str(roll))
    drone_view.pitch_var.set(str(pitch))
    drone_view.yaw_var.set(str(yaw))

    # Accelerometer
    drone_view.maxspeed_var.set(str(tar_spd))
    drone_view.x_var.set(str(x))
    drone_view.y_var.set(str(y))
    drone_view.z_var.set(str(z))

    # Mag compus
    drone_view.compass_var.set(str(compass))

    # Barometer
    drone_view.temp_var.set(str(temp))
    drone_view.press_var.set(str(pres))

    drone_view.mainloop()
